Subject: bug#71120: 29.3; buglet in cl-loop

From: Philip Kaludercic <[email-masked]>
Date: Wed, 29 May 2024 20:47:56 +0000

Philippe Schnoebelen <[email-masked]> writes:

> When I need a list of 100 random dice throws I write
>
> 	(cl-loop for i from 1 to 100 collect (random 6))
>
> It compiles just fine.
>
> If instead I use
>
> 	(cl-loop for _i from 1 to 100 collect (random 6))
>
> then I get a compilation warning:
>
> 	foo.el:1:18: Warning: variable ‘_i’ not left unused
>
> It should be the other way around.

The issue here is that the warning describes an issue in the output, in
the latter case

  (let* ((_i 1) (--cl-var-- nil))
    (while (<= _i 100)
      (setq --cl-var-- (cons (random 6) --cl-var--))
      (setq _i (+ _i 1)))
    (nreverse --cl-var--))

As you see, _i is both evaluated in (+ _i 1) and updated.

Here you have a minimal working example of the warning:

  (byte-compile (lambda () (let ((_x 3)) _x)))

  ;; Warning: variable ‘_x’ not left unused

My guess is that fixing this would require cl-loop to notice that the
counter is prefixed with a "_" and then use some other variable, but
that might lead to issues with existing code.  Perhaps this
transformation might be safe in that case:

  (let* ((<fresh-variable> 1) (--cl-var-- nil))
    (while (<= <fresh-variable> 100)
      (let ((_i <fresh-variable>))
	(setq --cl-var-- (cons (random 6) --cl-var--))
	(setq <fresh-variable> (+ <fresh-variable> 1))))
    (nreverse --cl-var--))

I have added Mattias and Stefan to the CCs, as they'll probably have
more qualified comments to add.

>
> The variable 'i' is unused in the first form and that deserves a
> warning at compile time. Otherwise the compiler will not help me catch
> the typo in
>
> 	(cl-loop for i from 0 to 10 do
> 	   (cl-loop for j from 0 to 10 do
> 	      (foo j j))) ;; <<<=== typo, I meant (foo i j)
>
>
> --ph.schnoebelen, happy and thankful GNU Emacs user since 1983 (Thanks
>   to all involved!!)
>
>
>
>
>

-- 
	Philip Kaludercic on peregrine